﻿TEMPER_L 	EQU 	36H		;存放读出温度低位数据
TEMPER_H 	EQU 	35H		;存放读出温度高位数据
TEMPER		EQU	34H     ;存放转换后的8位温度值
TEMPER_DEC      EQU     33H          ;存放小数位
TEMPER_NUM 	EQU 	60H		;缓冲单元
FLAG1 		BIT	00H     
DQ 		BIT	P3.3		;一线总线控制端口
SDA	BIT 	P1.0
SCL	BIT  	P1.1
WSLA	EQU	70H
RSLA	EQU	71H
DISDA	EQU	20H
DISCON	EQU	08H
DATA_1	EQU	40H
COUNT	EQU 	50H

ORG	0000H
LJMP	MAIN
ORG 001BH
AJMP INT_T1
ORG	0100H

MAIN:	MOV 	SP,#70H
	
	MOV	TMOD,#11H
	MOV 	TL1,#0B3H
	MOV 	TH1,#0FEH
	SETB TR1
	SETB ET1
	SETB EA

	CLR	P1.7
	LCALL	DELAY
	SETB	P1.7

	MOV	DATA_1,#0FFH
	MOV	DATA_1+1,#0FFH
	MOV	DATA_1+2,#0FFH
	MOV	DATA_1+3,#0FFH
	MOV	DATA_1+4,#0FFH
	MOV	DATA_1+5,#0FFH
	MOV	DATA_1+6,#0FFH
	MOV	DATA_1+7,#0FFH

	MOV	DPTR,#LEDSEG
	MOV	R7,#DISCON
	MOV	R0,#DISDA
	MOV	R1,#DATA_1
LOOP1:	MOV	A,@R1
	MOVC	A,@A+DPTR
	MOV	@R0,A
	INC	R1
	INC	R0
	DJNZ	R7,LOOP1
LP1:	CLR EA
	LCALL 	GET_TEMPER		;从DS18B20读出温度数据	
	SETB EA
	LCALL	TEMPER_COV		;转换读出的温度数据并保存
	MOV 	A,TEMPER
	MOV	COUNT,A
	LCALL	CF
	;MOV	22H,R3
	MOV	22H,R4
	MOV	21H,R5
        MOV     20H,R6

	MOV	R7,#DISCON
	MOV	R0,#DISDA
	MOV	R2,#10H
	MOV	R3,#WSLA
	LCALL	WRNBYT
	LCALL	DELAY

	SJMP 	LP1				;完成一次数字温度采集

	
INT_T1:
	PUSH PSW
	PUSH 06H
	MOV 	TL1,#033H
	MOV 	TH1,#0FEH

	MOV	R6,COUNT
	CJNE	R6,#1AH,N_EQUAL1		;上限26，高于26警报
	SJMP	OTHER
N_EQUAL1:JNC	GT_1C
	SJMP	OTHER
GT_1C:	
	CPL	P1.2
	SJMP 	EXIT

OTHER:	CJNE	R6,#14H,N_EQUAL2		;下限20
	SJMP	EXIT
N_EQUAL2:JNC	EXIT
	CPL	P1.2

EXIT:	
	POP 06H
	POP PSW
	RETI




GET_TEMPER:					;读出转换后的温度值
	SETB 	DQ 				;定时入口
BCD:	LCALL 	INIT_1820
	JB 	FLAG1,S22
	LJMP 	BCD 			; 若DS18B20不存在则返回
S22:	LCALL 	DELAY1
	MOV 	A,#0CCH 		; 跳过ROM匹配 0CCH
	LCALL 	WRITE_1820
	MOV 	A,#44H 			; 发出温度转换命令
	LCALL 	WRITE_1820		
	LCALL 	DELAY
CBA:	LCALL 	INIT_1820
	JB 	FLAG1,ABC
	LJMP 	CBA
ABC:	LCALL 	DELAY1
	MOV 	A,#0CCH 		; 跳过ROM匹配
	LCALL 	WRITE_1820
	MOV 	A,#0BEH 		; 发出读温度命令
	LCALL 	WRITE_1820
	LCALL 	READ_18200 		;READ_1820
	RET  

WRITE_1820:						;写DS18B20的程序
	MOV 	R2,#8
	CLR 	C
WR1:	CLR 	DQ
	MOV 	R3,#6	;延时24us
	DJNZ 	R3,$
	RRC 	A
	MOV 	DQ,C
	MOV 	R3,#23	;延时60us
	DJNZ 	R3,$
	SETB 	DQ		;一个写周期至少要维持60us以上
	NOP				;离下一个写周期至少要有1us间隔
	DJNZ 	R2,WR1
	SETB 	DQ
	RET

READ_18200:						; 读DS18B20的程序,从DS18B20中读出两个字节的温度数据
	MOV 	R4,#2 			; 将温度高位和低位从DS18B20中读出
	MOV 	R1,#36H 		; 低位存入36H(TEMPER_L),高位存入35H(TEMPER_H)
RE00:	MOV 	R2,#8
RE01:	CLR 	C
	SETB 	DQ
	NOP
	CLR	DQ		;DQ;DQ=0 15US内
	NOP			;18B20送数,主控器
	NOP			;必须完成DQ的采样
	SETB 	DQ	;主控器释放DQ
	MOV 	R3,#2
	DJNZ 	R3,$	;延时10us
	MOV 	C,DQ	;取dq数据位
	MOV 	R3,#23	;延时60us
	DJNZ 	R3,$
	RRC 	A
	DJNZ 	R2,RE01
	MOV 	@R1,A
	DEC 	R1
	DJNZ 	R4,RE00
	RET

TEMPER_COV:					; 将读出的数据进行转换
        MOV  A,TEMPER_L      ; 读取温度低字节（含小数）
        ANL  A,#0FH          ; 取出低4位（小数部分）
        MOV  B,#10           ; 将小数部分×10，转换为1位十进制
        MUL  AB              ; 结果在A中（0~9）
        MOV  B,#16
	DIV  AB
        MOV  TEMPER_DEC,A    ; 保存小数位

        MOV  A,TEMPER_L      ; 重新读取温度低字节
        ANL  A,#0F0H         ; 取出高4位（整数部分）
        SWAP A               ; 交换为正常整数
        MOV  TEMPER_NUM,A    ; 保存整数部分


TEMPER_COV1:
	MOV 	A,TEMPER_H
	ANL 	A,#07H
	SWAP 	A
	ADD 	A,TEMPER_NUM
	MOV 	TEMPER_NUM,A 	; 保存变换后的温度数据
	MOV	TEMPER,TEMPER_NUM
	RET

INIT_1820:					; DS18B20初始化程序
	SETB 	DQ
	NOP
	CLR 	DQ
	MOV 	R0,#80H
TSR1:	DJNZ 	R0,TSR1		;延时 300us
	SETB 	DQ
	MOV 	R0,#25H 	;96US
TSR2:	DJNZ 	R0,TSR2
	JNB 	DQ,TSR3
	LJMP 	TSR4 		; 延时
TSR3:	SETB 	FLAG1 		; 置标志位, 
	LJMP 	TSR5		; DS1820存在
TSR4:	CLR 	FLAG1 		; 清标志位, 
	LJMP 	TSR7		; DS1820不存在
TSR5:	MOV 	R0,#06BH 	; 延时200US
TSR6:	DJNZ 	R0,TSR6 	
TSR7:	SETB 	DQ
	RET

DELAY1:	MOV 	R7,#20H			;80us延时
	DJNZ 	R7,$
	RET

DELAY:	PUSH	00H
	PUSH	01H
	MOV	R0,#00
LP:	MOV     R1,#00H
	DJNZ	R1,$
	DJNZ	R0,LP
	POP	01H
	POP	00H
	RET

	
CF:	PUSH	02H
	PUSH	DPH
	PUSH	DPL
	
	MOV	DPTR,#LEDSEG

	MOV	B,#64H		;B=100
	DIV	AB		;A÷100，商存A，余数存
	MOVC	A,@A+DPTR
	MOV	R3,A
	
	MOV	A,B		;继续处理十位和个位
	MOV	B,#0AH		;B=10
	DIV	AB		;再除以10，A里存十位，B里存个位	
	MOVC	A,@A+DPTR
	MOV	R4,A		;R4存十位的字形码

	MOV  A,B
        MOVC A,@A+DPTR
        ORL  A,#01H          ; 点亮个位的DP段（小数点）
        MOV  R5,A            ; 个位七段码+小数点
    
        MOV  A,TEMPER_DEC    ; 小数部分
        MOVC A,@A+DPTR
        MOV  R6,A            ; 小数位七段码



	POP	DPL
	POP	DPH
	POP	02H
	RET

LEDSEG:	DB	0FCH,60H,0DAH,0F2H,66H,0B6H,0BEH,0E4H
	DB	0FEH,0F6H,0EEH,3EH,9CH,7AH,9EH,8EH
	DB	0FAH,1EH,12H,00H
;【附录一】由汇编语言编制的I2C通讯子程序
;【提  示】下列程序是在系统时钟为12MHZ（或11.0592MHZ），即NOP指令为1微秒左右。
;（1）带有内部单元地址的多字节写操作子程序 WRNBYT
;*******************************************************************
;通用的I2C通讯子程序（多字节写操作）
;入口参数R7字节数,R0:源数据块首地址
;R0原数据块首地址；R2从器件内部子地址;R3:外围器件地址（写）
;相关子程序WRBYT、STOP、CACK、STA
;*******************************************************************	
WRNBYT:	PUSH	PSW		
		PUSH	ACC				
WRADD:	MOV		A,R3		;取外围器件地地址（包含r/w=0）	
		LCALL	STA		;发送起始信号S  
		LCALL	WRBYT		;发送外围地址
		LCALL	CACK		;检测外围器件的应答信号
		JB		F0,WRADD	;如果应
		MOV		A,R2
		LCALL	WRBYT		;发送内部寄存器首地址
		LCALL	CACK		;检测外围器件的应答信号
		JB		F0,WRADD	;如果应答不正确返回重来 	
WRDA:	MOV		A,@R0
		LCALL	WRBYT		;发送外围地址                                 
		LCALL	CACK		;检测外围器件的应答信号
		JB		F0,WRADD	;如果应答不正确返回重来
		INC		R0
		DJNZ  	R7,WRDA
		LCALL	STOP 	
		POP		ACC
		POP		PSW
		RET 	       
;*******************************************************************
;*******************************************************************
;通用的I2C通讯子程序（多字节读操作）
;入口参数R7字节数；
;R0目标数据块首地址；R2从器件内部子地址；
;R3器件地址（写）；R4器件地址（读）
;相关子程序WRBYT、STOP、CACK、STA、MNACK 
;*******************************************************************	
RDADD:  PUSH	PSW			;从PCF8563的02H单元读入7个参数
		PUSH	ACC			;存放于20H-26H单元	
RDADD1:	LCALL	STA 
		MOV		A,R3		;取器件地址（写）
		LCALL	WRBYT		;发送外围地址
		LCALL	CACK		;检测外围器件的应答信号
		JB		F0,RDADD1	;如果应答不正确返回重来
		MOV		A,R2		;取内部地址	
		LCALL	WRBYT		;发送外围地址
		LCALL	CACK		;检测外围器件的应答信号
		JB		F0,RDADD1	;如果应答不正确返回重来	
		LCALL	STA
		MOV		A,R4		;取器件地址（读）
		LCALL	WRBYT		;发送外围地址
		LCALL	CACK		;检测外围器件的应答信号
		JB		F0,RDADD1	;如果应答不正确返回重来
RDN:	LCALL	RDBYT 	
		MOV		@R0,A
		DJNZ	R7,ACK
		LCALL	MNACK
		LCALL	STOP	
		POP		ACC
		POP		PSW
		RET
ACK:	LCALL	MACK
		INC		R0
		SJMP	RDN 

;**********************************************************************
;						启动信号子程序S 
;**********************************************************************
STA:	SETB	SDA		;启动信号S
		SETB	SCL
		NOP				;产生4.7US延时
		NOP
		NOP
		NOP
		NOP	
		CLR		SDA
		NOP				;产生4.7US延时
		NOP
		NOP
		NOP
		NOP 	
		CLR		SCL
		RET 
;**********************************************************************
;						停止信号子程序P 
;**********************************************************************
STOP:	CLR		SDA 	;停止信号P
		SETB	SCL
		NOP				;产生4.7US延时
		NOP
		NOP
		NOP
		NOP	
		SETB	SDA
		NOP				;产生4.7US延时
		NOP
		NOP
		NOP
		NOP	
		CLR		SCL
		CLR		SDA
		RET 
;**********************************************************************
;						应答信号子程序   MACK
;**********************************************************************
MACK:	CLR		SDA	;发送应答信号ACK
		SETB	SCL
		NOP			;产生4.7US延时
		NOP
		NOP
		NOP
		NOP
		CLR		SCL
		SETB	SDA
		RET
;**********************************************************************
;						非应答法信号子程序MNACK
;**********************************************************************
MNACK:	SETB	SDA		;发送非应答信号NACK
		SETB	SCL
		NOP				;产生4.7US延时
		NOP
		NOP
		NOP
		NOP
		CLR		SCL
		CLR		SDA
		RET
;**********************************************************************
;						应答检测子程序CACK
;**********************************************************************
CACK:	SETB	SDA		;应答位检测子程序
		SETB	SCL 
		CLR		F0
		MOV		C,SDA	;采样SDA
		JNC		CEND	;应答正确时转CEND
		SETB	F0		;应答错误时F0置一
CEND:	CLR		SCL
		RET
;**********************************************************************
;						发送一个字节子程序WRBYT
;**********************************************************************
WRBYT:	PUSH	06H
MOV		R6,#08H		;发送一个字节子程序 
WLP:	RLC		A 			;(入口参数A)
		MOV		SDA,C
		SETB	SCL
		NOP					;产生4.7US延时
		NOP
		NOP
		NOP
		NOP
		CLR		SCL
		DJNZ	R6,WLP
		POP		06H
		RET
;**********************************************************************
;						接收一个字节子程序RDBYT 
;**********************************************************************
RDBYT: 	PUSH	06H
		MOV		R6,#08H	;接收一个字节子程序
RLP:	SETB	SDA
		SETB	SCL
;  *******************************************
	NOP			;!!!!!产生大于15微秒的延时!!!!!!
	NOP 		;注意这是专门为ZLG7290
	NOP 		;添加的20微秒延时部分
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
;  ********************************************	
	MOV		C,SDA
	MOV		A,R2
	RLC		A
	MOV		R2,A
	CLR		SCL
	DJNZ	R6,RLP 		;(出口参数R2)
	POP		06H
	RET  
;**********************************************************************
	END
